
/******************************************************************************
* MODULE     : keyw_supports.cc
* DESCRIPTION: Using extern modules
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <dlfcn.h>
#include <evaluator.hh>
#include <file.hh>
#include <single.hh>
namespace mmx {

void
evaluator_rep::kw_supports_1 () {
  CHECK_SYNC (MMX_SUPPORTS);
  if (N (car (trace)) != 2) error (car (trace), "Bad supports instruction");
  list name (MMX_TRANSTYPE, car (trace) [1], VAL_STRING);
  evaluate_arg (name, KW_SUPPORTS_2);
}

void
evaluator_rep::kw_supports_2 () {
  CHECK_SYNC (MMX_SUPPORTS);
  // Input: (supports_2, module_name, cont, ...)
  string name= as_string (V (car (rem)));
  string lib = string ("mmx-" * name * ".so");

  bool ok=
    file_exists (lib) ||
    file_exists (sys_home * "/.mathemagix/lib/" * lib) ||
    file_exists (sys_lib_path * "/" * lib);

  cur= cadr (rem);
  rem= cons (value (single (ok), ID_BOOL), cddr (rem));
  // Output: (cont, none, ...)
  trace= cdr (trace);
}

} // namespace mmx
