
/******************************************************************************
* MODULE     : keyw_tuple.cc
* DESCRIPTION: Evaluation of tuples
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <match.hh>
namespace mmx {

void
evaluator_rep::kw_tuple_1 () {
  CHECK_SYNC2 (MMX_TUPLE, MMX_VTUPLE);
  evaluate_args (cdr (as_list (car (trace))), KW_TUPLE_2);
}

void
evaluator_rep::kw_tuple_2 () {
  CHECK_SYNC2 (MMX_TUPLE, MMX_VTUPLE);
  // INPUT: (tuple_2, args, cont, ...)
  list l= as_list (car (rem));
  generic vt  = car (car (trace));
  generic val = cons (vt, get_values (l));
  generic type= cons (vt == MMX_VTUPLE? ID_VCROSS: ID_CROSS, get_types (l));
  value res (val, type);
  cur= cadr (rem);
  rem= cons (res, cddr (rem));
  // OUTPUT: (cont, tuple_type, ...)
  trace= cdr (trace);
}

} // namespace mmx
