
/******************************************************************************
* MODULE     : lib_print_cross.cc
* DESCRIPTION: Printing tuples
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <printer.hh>
namespace mmx {

void
evaluator_rep::lib_print_cross_1 () {
  CHECK_SYNC (MMX_PRINT_CROSS);
  // Input: (print_cross_1, out, vals, types, cont, ...)
  printer out= as_printer (car (rem));
  if (car(trace)[1][2][0] == ID_VCROSS) out->out << "(vtuple!";
  else out->out << "(tuple!";
  cur= LIB_PRINT_CROSS_2;
  // Output: (print_cross_2, out, vals, types, cont, ...)
  lib_print_cross_2 ();
}

void
evaluator_rep::lib_print_cross_2 () {
  CHECK_SYNC (MMX_PRINT_CROSS);
  // Input: (print_cross_2, out, vals, types, cont, ...)
  printer out  = as_printer (car (rem));
  list    vals = as_list (cadr (rem));
  list    types= as_list (caddr (rem));
  if (nil (vals)) {
    out->out << ")";
    cur= value (out, ID_OSTREAM);
    rem= cdddr (rem);
    // Output: (cont, out, ...)
    trace= cdr (trace);
  }
  else {
    out->out << " ";
    generic x= value (car (vals), car (types));
    cur= list (MMX_LESSLESS_STR, value (out, ID_OSTREAM), x);
    rem= cons (LIB_PRINT_CROSS_3, out, cdr (vals), cdr (types), cdddr (rem));
    // Output: (instr, print_cross_3, out, rem_vals, rem_types, cont, ...)
  }
}

void
evaluator_rep::lib_print_cross_3 () {
  CHECK_SYNC (MMX_PRINT_CROSS);
  // Input: (instr, print_cross_3, out, vals, types, cont, ...)
  cur= LIB_PRINT_CROSS_2;
  rem= cdr (rem);
  lib_print_cross_2 ();
}

} // namespace mmx
