
/******************************************************************************
* MODULE     : file.hh
* DESCRIPTION: Loading and saving files
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __FILE_HH
#define __FILE_HH
#include <string.hh>
namespace mmx {

void insert_source (string& src, string name);
void find_location (int loc, string& src, string& name,
		    int& row, int& col);

bool file_exists (string file_name);
bool load (string file_name, string& s, bool decode= true);
bool load (string file_path, string file_name, string& s, bool decode= true);
bool save (string file_name, string s, bool decode= true);

string get_dir_name  (string name);
string get_file_name (string name);

int  system (string s);
void init_system ();
extern string sys_home;
extern string sys_load_path;
extern string sys_include_path;
extern string sys_lib_path;

}
#endif // __FILE_HH
