
/******************************************************************************
* MODULE     : symbols.cc
* DESCRIPTION: frequently used symbols
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <symbols.hh>
namespace mmx {

/******************************************************************************
* Mathemagix keyword names
******************************************************************************/

GC_GLOBAL (symbol, MMX_ACCESS, ".[]");
GC_GLOBAL (symbol, MMX_AMBIGUOUS, "ambiguous!");
GC_GLOBAL (symbol, MMX_AND, "&&");
GC_GLOBAL (symbol, MMX_ASSIGN, ":=");
GC_GLOBAL (symbol, MMX_BACKPRIME, "`");
GC_GLOBAL (symbol, MMX_BEGIN, "begin!");
GC_GLOBAL (symbol, MMX_BREAK, "break!");
GC_GLOBAL (symbol, MMX_CASE, "case!");
GC_GLOBAL (symbol, MMX_COMPLEMENT, "!!");
GC_GLOBAL (symbol, MMX_COMPOSE, "@");
GC_GLOBAL (symbol, MMX_CONTINUE, "continue!");
GC_GLOBAL (symbol, MMX_CROSS, "Cross");
GC_GLOBAL (symbol, MMX_DECLARE, "declare!");
GC_GLOBAL (symbol, MMX_DEFINE, "==");
GC_GLOBAL (symbol, MMX_DEFINEALIAS, ":==");
GC_GLOBAL (symbol, MMX_DIV, "div!");
GC_GLOBAL (symbol, MMX_DIVASSIGN, "div=!");
GC_GLOBAL (symbol, MMX_DOLLAR, "$");
GC_GLOBAL (symbol, MMX_DOT, ".");
GC_GLOBAL (symbol, MMX_DOTS, "..");
GC_GLOBAL (symbol, MMX_ELSE, "else!");
GC_GLOBAL (symbol, MMX_EQUAL, "=");
GC_GLOBAL (symbol, MMX_EQUIV, "<=>");
GC_GLOBAL (symbol, MMX_ERROR, "error!");
GC_GLOBAL (symbol, MMX_EXISTS, "exists!");
GC_GLOBAL (symbol, MMX_EXISTSVAL, "existsval!");
GC_GLOBAL (symbol, MMX_EXPORT, "export!");
GC_GLOBAL (symbol, MMX_FACTORIAL, ".!");
GC_GLOBAL (symbol, MMX_FOR, "for!");
GC_GLOBAL (symbol, MMX_FORALL, "forall!");
GC_GLOBAL (symbol, MMX_FORALLVAL, "forallval!");
GC_GLOBAL (symbol, MMX_FORIN, "forin!");
GC_GLOBAL (symbol, MMX_FUNCTION, "->");
GC_GLOBAL (symbol, MMX_GENERATE, "generate!");
GC_GLOBAL (symbol, MMX_GTR, ">");
GC_GLOBAL (symbol, MMX_GTREQ, ">=");
GC_GLOBAL (symbol, MMX_GTRGTR, ">>");
GC_GLOBAL (symbol, MMX_HAS, "has!");
GC_GLOBAL (symbol, MMX_HOLDS, "holds!");
GC_GLOBAL (symbol, MMX_IF, "if!");
GC_GLOBAL (symbol, MMX_JOIN, "join!");
GC_GLOBAL (symbol, MMX_IMPLIES, "=>");
GC_GLOBAL (symbol, MMX_IMPORT, "import!");
GC_GLOBAL (symbol, MMX_LAMBDA, "lambda!");
GC_GLOBAL (symbol, MMX_LESS, "<");
GC_GLOBAL (symbol, MMX_LESSEQ, "<=");
GC_GLOBAL (symbol, MMX_LESSLESS, "<<");
GC_GLOBAL (symbol, MMX_LESSLESS_VAR, "<<*");
GC_GLOBAL (symbol, MMX_LESSLESS_STR, "<<%");
GC_GLOBAL (symbol, MMX_LOAD, "load");
GC_GLOBAL (symbol, MMX_LOCAL, "local!");
GC_GLOBAL (symbol, MMX_LOOP, "loop!");
GC_GLOBAL (symbol, MMX_MIGRATE, "migrate!");
GC_GLOBAL (symbol, MMX_MOD, "mod!");
GC_GLOBAL (symbol, MMX_MODASSIGN, "mod=!");
GC_GLOBAL (symbol, MMX_MODIFY, "modify!");
GC_GLOBAL (symbol, MMX_MINUS, "-");
GC_GLOBAL (symbol, MMX_MINUSASSIGN, "-=");
GC_GLOBAL (symbol, MMX_NEW_INT, "literal_int!");
GC_GLOBAL (symbol, MMX_NEW_FLOAT, "literal_float!");
GC_GLOBAL (symbol, MMX_NEW_STRING, "literal_string!");
GC_GLOBAL (symbol, MMX_NOT, "!");
GC_GLOBAL (symbol, MMX_NOTGTR, "!>");
GC_GLOBAL (symbol, MMX_NOTGTREQ, "!>=");
GC_GLOBAL (symbol, MMX_NOTLESS, "!<");
GC_GLOBAL (symbol, MMX_NOTLESSEQ, "!<=");
GC_GLOBAL (symbol, MMX_NUMBER, "#");
GC_GLOBAL (symbol, MMX_OBTAIN, "obtain!");
GC_GLOBAL (symbol, MMX_OMINUS, "@-");
GC_GLOBAL (symbol, MMX_OOVER, "@/");
GC_GLOBAL (symbol, MMX_OPLUS, "@+");
GC_GLOBAL (symbol, MMX_OR, "||");
GC_GLOBAL (symbol, MMX_OTIMES, "@*");
GC_GLOBAL (symbol, MMX_OVER, "/");
GC_GLOBAL (symbol, MMX_OVERASSIGN, "/=");
GC_GLOBAL (symbol, MMX_PLUS, "+");
GC_GLOBAL (symbol, MMX_PLUSASSIGN, "+=");
GC_GLOBAL (symbol, MMX_POSTDEC, ".--");
GC_GLOBAL (symbol, MMX_POSTINC, ".++");
GC_GLOBAL (symbol, MMX_POWER, "^");
GC_GLOBAL (symbol, MMX_PREDEC, "--");
GC_GLOBAL (symbol, MMX_PREINC, "++");
GC_GLOBAL (symbol, MMX_PRIME, "'");
GC_GLOBAL (symbol, MMX_RETRIEVE, "retrieve");
GC_GLOBAL (symbol, MMX_RETURN, "return!");
GC_GLOBAL (symbol, MMX_SEQAND, "and!");
GC_GLOBAL (symbol, MMX_SEQOR, "or!");
GC_GLOBAL (symbol, MMX_SPLIT, "split!");
GC_GLOBAL (symbol, MMX_SQRT, "sqrt");
GC_GLOBAL (symbol, MMX_SQTUPLE, "[]");
GC_GLOBAL (symbol, MMX_STEP, "step!");
GC_GLOBAL (symbol, MMX_SUPPORTS, "supports");
GC_GLOBAL (symbol, MMX_TIMES, "*");
GC_GLOBAL (symbol, MMX_TIMESASSIGN, "*=");
GC_GLOBAL (symbol, MMX_TRANSTYPE, ":>");
GC_GLOBAL (symbol, MMX_TUPLE, "tuple!");
GC_GLOBAL (symbol, MMX_TUPLETYPE, "Tuple");
GC_GLOBAL (symbol, MMX_TYPE, ":");
GC_GLOBAL (symbol, MMX_UNEQUAL, "!=");
GC_GLOBAL (symbol, MMX_UNTIL, "until!");
GC_GLOBAL (symbol, MMX_USE, "use");
GC_GLOBAL (symbol, MMX_VCROSS, "VCross");
GC_GLOBAL (symbol, MMX_VTUPLE, "vtuple!");
GC_GLOBAL (symbol, MMX_VTUPLETYPE, "VTuple");
GC_GLOBAL (symbol, MMX_WHILE, "while!");
GC_GLOBAL (symbol, MMX_XOR, "^^");
GC_GLOBAL (symbol, MMX_YIELD, "yield!");

/******************************************************************************
* Mathemagix types
******************************************************************************/

GC_GLOBAL (symbol, MMX_CLASS, "Class");
GC_GLOBAL (symbol, MMX_GENERIC, "Generic");
GC_GLOBAL (symbol, MMX_BOOL, "Bool");
GC_GLOBAL (symbol, MMX_INT, "Int");
GC_GLOBAL (symbol, MMX_STRING, "String");
GC_GLOBAL (symbol, MMX_OSTREAM, "OStream");
GC_GLOBAL (symbol, MMX_OSTRSTREAM, "OStrstream");
GC_GLOBAL (symbol, MMX_LITERAL_INT, "Literal_Int");
GC_GLOBAL (symbol, MMX_LITERAL_FLOAT, "Literal_Float");
GC_GLOBAL (symbol, MMX_LITERAL_STRING, "Literal_String");
GC_GLOBAL (symbol, MMX_ALIAS, "Alias");
GC_GLOBAL (symbol, MMX_GENERATOR, "Generator");
GC_GLOBAL (symbol, MMX_LIST, "List");
GC_GLOBAL (symbol, MMX_ARRAY, "Array");
GC_GLOBAL (symbol, MMX_TABLE, "Table");
GC_GLOBAL (symbol, MMX_POINTER, "Pointer");

GC_GLOBAL (mirror, ID_CLASS, mirror (MMX_CLASS));
GC_GLOBAL (mirror, ID_GENERIC, mirror (MMX_GENERIC));
GC_GLOBAL (mirror, ID_BOOL, mirror (MMX_BOOL));
GC_GLOBAL (mirror, ID_INT, mirror (MMX_INT));
GC_GLOBAL (mirror, ID_STRING, mirror (MMX_STRING));
GC_GLOBAL (mirror, ID_OSTREAM, mirror (MMX_OSTREAM));
GC_GLOBAL (mirror, ID_OSTRSTREAM, mirror (MMX_OSTRSTREAM));
GC_GLOBAL (mirror, ID_LITERAL_INT, mirror (MMX_LITERAL_INT));
GC_GLOBAL (mirror, ID_LITERAL_FLOAT, mirror (MMX_LITERAL_FLOAT));
GC_GLOBAL (mirror, ID_LITERAL_STRING, mirror (MMX_LITERAL_STRING));
GC_GLOBAL (mirror, ID_ALIAS, mirror (MMX_ALIAS));
GC_GLOBAL (mirror, ID_GENERATOR, mirror (MMX_GENERATOR));
GC_GLOBAL (mirror, ID_LIST, mirror (MMX_LIST));
GC_GLOBAL (mirror, ID_ARRAY, mirror (MMX_ARRAY));
GC_GLOBAL (mirror, ID_TABLE, mirror (MMX_TABLE));
GC_GLOBAL (mirror, ID_POINTER, mirror (MMX_POINTER));
GC_GLOBAL (mirror, ID_CROSS, mirror (MMX_CROSS));
GC_GLOBAL (mirror, ID_TUPLETYPE, mirror (MMX_TUPLETYPE));
GC_GLOBAL (mirror, ID_VCROSS, mirror (MMX_VCROSS));
GC_GLOBAL (mirror, ID_VTUPLETYPE, mirror (MMX_VTUPLETYPE));
GC_GLOBAL (mirror, ID_FUNCTION, mirror (MMX_FUNCTION));
GC_GLOBAL (mirror, ID_FORALL, mirror (MMX_FORALL));
GC_GLOBAL (mirror, ID_EXISTS, mirror (MMX_EXISTS));
GC_GLOBAL (mirror, ID_IMPLIES, mirror (MMX_IMPLIES));
GC_GLOBAL (mirror, ID_AND, mirror (MMX_AND));
GC_GLOBAL (mirror, ID_OR, mirror (MMX_OR));
GC_GLOBAL (mirror, ID_NOT, mirror (MMX_NOT));

GC_GLOBAL (value, VAL_CLASS, value (ID_CLASS, ID_CLASS));
GC_GLOBAL (value, VAL_GENERIC, value (ID_GENERIC, ID_CLASS));
GC_GLOBAL (value, VAL_BOOL, value (ID_BOOL, ID_CLASS));
GC_GLOBAL (value, VAL_INT, value (ID_INT, ID_CLASS));
GC_GLOBAL (value, VAL_STRING, value (ID_STRING, ID_CLASS));
GC_GLOBAL (value, VAL_OSTREAM, value (ID_OSTREAM, ID_CLASS));
GC_GLOBAL (value, VAL_OSTRSTREAM, value (ID_OSTRSTREAM, ID_CLASS));

/******************************************************************************
* Miscellaneous
******************************************************************************/

GC_GLOBAL (symbol, CONV_FUNCTION, "0#");
GC_GLOBAL (symbol, CONV_ARGUMENT, "1#");
GC_GLOBAL (symbol, CONV_ALIASES, "aliases#");
GC_GLOBAL (symbol, CONV_AMBIGUOUS, "ambiguous#");
GC_GLOBAL (symbol, CONV_APPLY, "apply#");
GC_GLOBAL (symbol, CONV_CROSS, "cross#");
GC_GLOBAL (symbol, CONV_FORALL, "forall#");
GC_GLOBAL (symbol, CONV_IGNORE, "ignore#");
GC_GLOBAL (symbol, CONV_LAMBDA, "lambda#");
GC_GLOBAL (symbol, CONV_SINGLET, "singlet#");
GC_GLOBAL (symbol, CONV_TEMPLATE, "template#");
GC_GLOBAL (symbol, CONV_UNALIAS, "unalias#");
GC_GLOBAL (symbol, CONV_UNAND, "unand#");
GC_GLOBAL (symbol, CONV_UNCROSS, "uncross#");
GC_GLOBAL (symbol, CONV_VCROSS, "vcross#");

GC_GLOBAL (symbol, CONT_BREAK, "break...");
GC_GLOBAL (symbol, CONT_RETURN, "return...");
GC_GLOBAL (symbol, CONT_YIELD, "yield...");
GC_GLOBAL (symbol, MISC_DONE, "done*");
GC_GLOBAL (symbol, MISC_GENERATE, "generate*");
GC_GLOBAL (symbol, MISC_SAVE, "save*");
GC_GLOBAL (symbol, MISC_TODO, "todo*");
GC_GLOBAL (symbol, MISC_YIELD, "yield*");

GC_GLOBAL (symbol,  MMX_VOID, "Void");
GC_GLOBAL (generic, ID_VOID, list (ID_CROSS));
GC_GLOBAL (value,   VAL_VOID, value (ID_VOID, ID_CLASS));
GC_GLOBAL (value,   VAL_NONE, value (generic (), ID_VOID));
GC_GLOBAL (symbol,  MMX_EXCEPTION, "Exception");
GC_GLOBAL (generic, ID_EXCEPTION, MMX_EXCEPTION);
GC_GLOBAL (value,   VAL_EXCEPTION, value (ID_EXCEPTION, ID_CLASS));
GC_GLOBAL (value,   VAL_DONE, value (symbol ("done"), ID_EXCEPTION));
GC_GLOBAL (symbol,  MMX_UNIVERSAL_VAR, "X#");
GC_GLOBAL (generic, ID_UNIVERSAL,
	    list (ID_FORALL, MMX_UNIVERSAL_VAR, MMX_UNIVERSAL_VAR));

/******************************************************************************
* The name of the constructor for a given type
******************************************************************************/

symbol
MMX_NEW (generic type) {
  while (is_list (type)) type= car (type);
  while (is_mirror (type)) type= S (as_mirror (type));
  while (is_symbol (type)) type= S (as_symbol (type));
  if (is_string (type)) return symbol (locase (as_string (type)));
  fatal_error ("Bad type", "MMX_NEW", "symbols.cc");
  exit (1);
}

} // namespace mmx
