
/******************************************************************************
* MODULE     : gc_test.cc
* DESCRIPTION: Test garbage collector and strings
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <string.hh>
#include <symbol.hh>
using namespace mmx;

#ifdef SUPPORTS_GC

int
main () {
  GC_LOCAL (int, i, 0);
  GC_LOCAL (string, s, "");
  GC_LOCAL (symbol, x, "holala");

  cout << lf << "First test" << lf << hrule;
  gc_inspect ();
  cout << lf;
  gc_show_objects (3);

  cout << lf << "Collect garbage" << lf << hrule;
  gc_collect ();
  gc_inspect ();
  cout << lf;
  gc_show_objects (3);

  cout << lf << "Second test" << lf << hrule;
  for (i=0; i<10; i++) {
    s= string ("Hallo allemaal");
    cout << i << ": " << s << "\n";
    s= string ("Hop");
    cout << i << ": " << s << "\n";
  }
  cout << lf;
  gc_inspect ();
  cout << lf;
  gc_show_objects (3);

  cout << lf << "Collect garbage" << lf << hrule;
  gc_collect ();
  gc_inspect ();
  cout << lf;
  gc_show_objects (3);

  cout << "s = " << s << " on exit\n";
  return 0;
}

#else

int
main () {
  cout << "No garbage collector available\n";
  return 0;
}

#endif
