
/******************************************************************************
* MODULE     : alias.hh
* DESCRIPTION: Aliases
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __ALIAS_HH
#define __ALIAS_HH
#include <genalias.hh>
namespace mmx {

class alias_rep: public genalias_rep {
protected:
  generic& ref;      // to who do we refer
  generic  caution;  // markable outer structure containing ref
  bool alloc_flag;   // should we free &ref on destruction?

protected:
  size_t Size ();
  void Mark ();
  int Type ();

public:
  inline alias_rep (generic& g, generic h, bool f):
    ref (g), caution (h), alloc_flag (f) {}
  inline ~alias_rep () { if (alloc_flag) delete &ref; }
  inline generic get () { return ref; }
  inline void set (generic val) {
    if (is_glued (ref) && is_glued (val)) ref->Assign_me (val);
    else if (is_glued (val)) ref= copy (val);
    else ref= val; }
  inline generic& get_ref () { return ref; }
  inline void set_caution (generic what) { caution= what; }

  friend class alias;
};

class alias {
DEFAULT_METHODS(alias);
public:
  inline alias (generic& ref, generic caution, bool alloc_flag):
    rep (new alias_rep (ref, caution, alloc_flag)) {}
};

}
#endif // __ALIAS_HH
