
/******************************************************************************
* MODULE     : genalias.cc
* DESCRIPTION: Generic aliases
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <genalias.hh>
namespace mmx {

/******************************************************************************
* Default implementation of some required functions for generic structures
******************************************************************************/

void
genalias_rep::Print (ostream& out) {
  out << genalias (this);
}

bool
genalias_rep::Is_genalias () {
  return true;
}

/******************************************************************************
* Default implementations of virtual routines for generic tables
******************************************************************************/

generic
genalias_rep::get () {
  fatal_error ("no get function associated to genalias",
	       "genalias_rep::contains", "genalias.cc");
  exit (1);
}

void
genalias_rep::set (generic val) {
  (void) val;
  fatal_error ("no set function associated to genalias",
	       "genalias_rep::contains", "genalias.cc");
  exit (1);
}

generic&
genalias_rep::get_ref () {
  fatal_error ("no get_ref function associated to genalias",
	       "genalias_rep::contains", "genalias.cc");
  exit (1);
}

void
genalias_rep::set_caution (generic what) {
  fatal_error ("no set_caution function associated to genalias",
	       "genalias_rep::set_caution", "genalias.cc");
  exit (1);
}

/******************************************************************************
* Routines for generic aliases
******************************************************************************/

ostream&
operator << (ostream& out, genalias a) {
  return print (out, "#alias", a->get ());
}

} // namespace mmx
