
/******************************************************************************
* MODULE     : serializer.cc
* DESCRIPTION: serializers
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <serializer.hh>
#include <symbol.hh>
namespace mmx {

/******************************************************************************
* Required routines for generic structures
******************************************************************************/

size_t
serializer_rep::Size () {
  return sizeof (serializer_rep);
}

void
serializer_rep::Mark () {
  mark (out);
}

int
serializer_rep::Type () {
  return SERIALIZER_TYPE;
}

void
serializer_rep::Print (ostream& out) {
  out << serializer (this);
}

/******************************************************************************
* Routines for serializers
******************************************************************************/

ostream&
operator << (ostream& out, serializer ser) {
  if (long_print_format ()) out << "#serializer<";
#ifdef OLD_CPP
  char* s= ser->out.str();
  int i, n= ser->out.pcount ();
  for (i=0; i<n; i++) out << s[i];
#else
  std::string s= ser->out.str();
  int i, n= s.length ();
  for (i=0; i<n; i++) out << s[i];
#endif
  if (long_print_format ()) out << ">";
  return out;
}

string
as_string (serializer ser) {
#ifdef OLD_CPP
  if (ser->out.pcount () == 0) return "";
  else return string (ser->out.str(), ser->out.pcount ());
#else
  std::string s= ser->out.str();
  return string ((char*) ((void*) s.data()), s.length());
#endif
}

printer
as_printer (serializer ser) {
  return printer (symbol ("string"), ser->out);
}

} // namespace mmx
