
/******************************************************************************
* MODULE     : value.hh
* DESCRIPTION: mathemagix values
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __VALUE_HH
#define __VALUE_HH
#include <list.hh>
namespace mmx {

class value_rep: public generic_rep {
public:
  generic val;
  generic type;

public:
  size_t Size ();
  void Mark ();
  int  Type ();
  bool Equal (generic g);
  generic Copy ();
  void Print (ostream& out);

public:
  inline value_rep (generic val2, generic type2):
    val (val2), type (type2) {}

  friend class value;
};

class value {
DEFAULT_METHODS(value);
public:
  inline value (generic val, generic type);

  inline bool operator == (value val);
  inline bool operator != (value val);
  friend value copy (value a);
  friend ostream& operator << (ostream& out, value i);
};

inline value::value (generic val, generic type):
  rep (new value_rep (val, type)) {}
inline bool value::operator == (value val) {
  return (rep->val == val->val) && (rep->type == val->type); }
inline bool value::operator != (value val) {
  return (rep->val != val->val) || (rep->type != val->type); }

inline generic V (generic g) { return as_value (g) -> val; }
inline generic T (generic g) { return as_value (g) -> type; }

list get_values (list l);
list get_types (list l);
list flatten_vars (list l);
list flatten_types (list l);

}
#endif // __VALUE_HH
